---
schema_version: "1"
id: d78c16c5fb78f601cb332661f477c35d23aee1f02c4dffdb0715df10bd20be39
title: Data Products (deprecated)
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/b2c-commerce/references/generated-api-specs/ocapi-data-products.md
canonical_url: https://developer.salesforce.com/docs/commerce/b2c-commerce/references/ocapi-data-products
source_site: developer.salesforce.com
content_type: documentation
content_hash: f668f6b4a768e569fe7d15c3cd1b1ec0dea1ebb1f80d56e89dcd84e4b7eb6f7b
products:
  - B2C Commerce
  - Salesforce APIs
---
Data Products (deprecated)

# Data Products (deprecated)

Data API endpoints enable developers to build applications for merchants: Create, update, delete business objects, like products, customers, pricing and promotions or assignments. They typically provide read and write access and are designed for moderate usage.

**Version:** 25.6

## Servers

*   `https://{host}/s/-/dw/data/v25_6`

Protocols: https.

## Security

*   `oauth2_application` (oauth2) Authentication flow with client ID and password with account manager.
    *   OAuth flow application (tokenUrl: https://account.demandware.com:443/dwsso/oauth2/access\_token)
    *   Scope x-info: Scopes are NOT supported. This is just a dummy, because the 'scopes' field is required.
*   `client_id` (apiKey) Add client ID for application identification. Alternative as 'client\_id' query parameter.
    *   API key in header: x-dw-client-id

## Operations

### GET Get Product

`GET /products/{id}`

Operation ID: `Get Product`. Tags: products. Security: oauth2\_application.

Action to get product information.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.

#### Parameters

*   `id` (path, string, required) The product ID.  
    Minimum length: 1.
*   `site_id` (query, string) The site context.
*   `expand` (query, array of string)
    
    The list of expansions that can be applied to the product. They are:
    
    *   'all' will retrieve all the product properties.
        
    *   'availability' will retrieve the following properties:
        
        *   ats
            
        *   in\_stock
            
        *   online
            
    *   'images' will retrieve the following properties:
        
        *   image
            
        *   image\_groups
            
    *   'all\_images' used with images will retrieve the following properties, including the images specified for its variants and variation groups:
        
        *   image
            
        *   image\_groups
            
    *   'categories' will retrieve the following properties:
        
        *   assigned\_categories
            
        *   primary\_category
            
        *   classification\_category
            
    *   'options' will retrieve the following properties:
        
        *   product\_options
            
    *   'prices' will retrieve the following properties:
        
        *   price
            
        *   price\_currency
            
    *   'variations' will retrieve the following properties:
        
        *   master
            
        *   variation\_attributes
            
        *   variation\_groups
            
        *   variation\_values
            
        *   variants
            
    *   'sets' will retrieve the following properties:
        
        *   set\_products
            
        *   product\_sets
            
    *   'bundles' will retrieve the following properties:
        
        *   product\_bundles
            
        *   bundled\_products
            
    
    Note that only variants with variation values are retrieved for a product of type variation master.
    

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product`.
    

### PUT Create Product

`PUT /products/{id}`

Operation ID: `Create Product`. Tags: products. Security: oauth2\_application.

Creates a product using the information provided. If a product exists with the same identifier, it is cleared and overwritten unless the request includes the header x-dw-validate-existing=true. Note that the following read-only attributes aren't replaced: `assigned_categories` , `bundled_products` , `classification_category` , `creation_date` , `default_variant_id` , `image` , `image_groups` , `last_modified` , `owning_catalog_name` , `price_per_unit` , `primary_categories` , `primary_category_id` , `product_bundles` , `product_options` , `product_sets` , `set_products` , `type` , `variants` , `variation_attributes` , `variation_groups` , and `variation_values` .

This endpoint may return the following faults:

*   400 - IdConflictException - Indicates the ID in request URL does not match the ID in the product document.
*   400 - ProductDuplicateException - Indicate the product is already existed.
*   400 - ProductInvalidException - Indicates the catalog is not provided in the request.
*   404 - CatalogNotFoundException - Indicates the catalog is not found.

#### Parameters

*   `id` (path, string, required) The product ID.  
    Minimum length: 1. Maximum length: 100.
*   `x-dw-validate-existing` (header, boolean)

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product`.

#### Responses

*   **400** `IdConflictException` - Indicates the ID in request URL does not match the ID in the product document. or `ProductDuplicateException` - Indicate the product is already existed. or `ProductInvalidException` - Indicates the catalog is not provided in the request.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Indicates the catalog is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product`.
    

### DELETE Delete Product

`DELETE /products/{id}`

Operation ID: `Delete Product`. Tags: products. Security: oauth2\_application.

Deletes the product by ID

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.

#### Parameters

*   `id` (path, string, required) The product ID.  
    Minimum length: 1. Maximum length: 100.

#### Responses

*   **204**
*   **404** `ProductNotFoundException` - Indicates the product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Product

`PATCH /products/{id}`

Operation ID: `Update Product`. Tags: products. Security: oauth2\_application.

Update a product using the information provided.

Fields that can be updated: name, page\_description, long\_description, page\_title, page\_keywords, brand, ean,upc, manufacture\_sku, manufacture\_name, searchable, unit, searchable, online\_flag, default\_variant\_id, valid\_to, valid\_from, tax\_class\_id, localized\_tax\_class\_id.

This endpoint may return the following faults:

*   400 - IdConflictException - Indicates the ID in request URL does not match the ID in the product document.
*   400 - ProductDefaultVariantException - Indicates there is a problem to set default variant for a product.
*   404 - ProductNotFoundException - Indicates the product to be updated is not found.

#### Parameters

*   `id` (path, string, required) The product ID.  
    Minimum length: 1. Maximum length: 100.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product`.

#### Responses

*   **400** `IdConflictException` - Indicates the ID in request URL does not match the ID in the product document. or `ProductDefaultVariantException` - Indicates there is a problem to set default variant for a product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product to be updated is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product`.
    

### POST Search Variants

`POST /products/{id}/variant_search`

Operation ID: `Search Variants`. Tags: products. Security: oauth2\_application.

Searches product variations for master product or variation group product.

The query attribute specifies a complex query that can be used to narrow down the search. This is the list of searchable attributes:

*   id - String
    
*   product\_id - String
    
*   name - String
    
*   online - SiteSpecific Boolean
    
*   in\_stock - Boolean
    
*   searchable - SiteSpecific Boolean
    
*   ats - Actual available quantity to sell - Double
    
*   variation\_attribute.ATTRIBUTE\_ID (Ex:variation\_attribute.color) - String
    

Sortable Fields:

*   id - String
    
*   product\_id - String
    
*   name - String
    
*   online - SiteSpecific Boolean
    
*   in\_stock - Boolean
    
*   searchable - SiteSpecific Boolean
    
*   ats - Actual available quantity to sell - Double
    

Note: The calculated value of "online" and "searchable" is used in the search/sort.

A search/sort by the the site specific attributes require the Site ID query parameter to be set. They are "online", "in\_stock", "searchable" and "ats".

We assume that every field that starts with variation\_attribute. is searchable and dot is followed by ATTRIBUTE\_ID".

The list of expansions to retrieve product information. The expand values available are:

*   \_base - Basic product information is retrieved. This expand is included by default.
    
*   all - All product information including the following properties are retrieved:
    
    *   image
        
    *   price - site\_id has to be provided to see this property
        
    *   price\_currency - site\_id has to be provided to see this property
        
*   availability - Information related to the availability of the product variation. This expand is not included by default.
    
    *   ats - site\_id has to be provided to see this property
        
    *   in\_stock - site\_id has to be provided to see this property
        
    *   online - site\_id has to be provided to see this property
        
    *   searchable
        
*   variations - Information related to product variation is retrieved. This expand is included by default.
    
*   attributes - Information related to product variation attributes is retrieved. This expand is not included by default.
    

This endpoint may return the following faults:

*   400 - MalformedSearchParameterException - Thrown if the query is ill-formed.
*   400 - ProductNotMasterGroupException - Thrown if the id is not the product id of a Variation Master product or Variation Group product.
*   400 - SiteIdMissingForSiteSpecificFilterException - Thrown if the Site ID query parameter is missing in the search of Variants by a site-specific product attribute.
*   404 - ProductNotFoundException - Thrown if the product is not found.

#### Parameters

*   `id` (path, string, required) The product id of master product or variation group product
*   `site_id` (query, string) The id of the site to get site specific product attributes.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `search_request`.

#### Responses

*   **400** `MalformedSearchParameterException` - Thrown if the query is ill-formed. or `ProductNotMasterGroupException` - Thrown if the id is not the product id of a Variation Master product or Variation Group product. or `SiteIdMissingForSiteSpecificFilterException` - Thrown if the Site ID query parameter is missing in the search of Variants by a site-specific product attribute.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Thrown if the product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variant_search_result`.
    

### GET Get Variation Groups

`GET /products/{master_product_id}/variation_groups`

Operation ID: `Get Variation Groups`. Tags: products. Security: oauth2\_application.

Reads variation groups for a product master.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates that the given product is not a variation master.
*   404 - ProductNotFoundException - Indicates the master product is not found.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product.  
    Minimum length: 1.
*   `site_id` (query, string) The site context.
*   `start` (query, integer (int32)) The start index of the variation groups to return (defaults to 0).
*   `count` (query, integer (int32)) The maximum number of variation groups to return (defaults to 25).
*   `select` (query, string) A selector that specifies the fields to return in the variation groups document.
*   `expand` (query, array of string) The valid expands are {price,availability}

#### Responses

*   **400** `ProductNotMasterException` - Indicates that the given product is not a variation master.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_groups`.
    

### GET Get Variation Group

`GET /products/{master_product_id}/variation_groups/{id}`

Operation ID: `Get Variation Group`. Tags: products. Security: oauth2\_application.

Read a variation group for a product master.

This endpoint may return the following faults:

*   400 - ProductIsNotVariationGroupException - Indicates the product specified is not a variation group.
*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   404 - ProductNotFoundException - Indicates either the master product or the variation group product cannot be found.
*   404 - VariationGroupNotFoundException - Indicates the product does not belong to the master product.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product that contains the variation group.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation group product.  
    Minimum length: 1.
*   `site_id` (query, string)
*   `expand` (query, array of string) The valid expands are {price,availability}

#### Responses

*   **400** `ProductIsNotVariationGroupException` - Indicates the product specified is not a variation group. or `ProductNotMasterException` - Indicates the master product id does not represent a master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation group product cannot be found. or `VariationGroupNotFoundException` - Indicates the product does not belong to the master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_group`.
    

### PUT Assign Variation Group

`PUT /products/{master_product_id}/variation_groups/{id}`

Operation ID: `Assign Variation Group`. Tags: products. Security: oauth2\_application.

Assign a variation group for a product master. If the variation group product does not initially exist, one is created using the body passed in.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   400 - VariationValueNotValidException - Indicates the values passed are not valid for the variation attributes.
*   404 - ProductNotFoundException - Indicates either the master product or the variation group product cannot be found.
*   404 - VariationAttributeValueNotFoundException - Indicates the value passed into a variation attribute is not one found in the valid values.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product that contains the variation group.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation group product.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_group`.

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product id does not represent a master product. or `VariationValueNotValidException` - Indicates the values passed are not valid for the variation attributes.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation group product cannot be found. or `VariationAttributeValueNotFoundException` - Indicates the value passed into a variation attribute is not one found in the valid values.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_group`.
    

### DELETE Unassign Variation Group

`DELETE /products/{master_product_id}/variation_groups/{id}`

Operation ID: `Unassign Variation Group`. Tags: products. Security: oauth2\_application.

Unassign a variation group product from a product master. The variation group product is not deleted: it remains as a normal product after unsassign.

This endpoint may return the following faults:

*   400 - ProductIsNotVariationGroupException - Indicates product specified is not a variation group.
*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   404 - ProductNotFoundException - Indicates either the master product or the variation group product cannot be found.
*   404 - VariationGroupNotFoundException - Indicates the product does not belong to the master product.

#### Parameters

*   `master_product_id` (path, string, required)  
    Minimum length: 1.
*   `id` (path, string, required)  
    Minimum length: 1.

#### Responses

*   **204**
*   **400** `ProductIsNotVariationGroupException` - Indicates product specified is not a variation group. or `ProductNotMasterException` - Indicates the master product id does not represent a master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation group product cannot be found. or `VariationGroupNotFoundException` - Indicates the product does not belong to the master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Variation Group

`PATCH /products/{master_product_id}/variation_groups/{id}`

Operation ID: `Update Variation Group`. Tags: products. Security: oauth2\_application.

Update a variation group for a product master.

This endpoint may return the following faults:

*   400 - ProductIsNotVariationGroupException - Indicates product specified is not a variation group.
*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   400 - VariationValueNotValidException - Indicates the values passed are not valid for the variation attributes.
*   404 - ProductNotFoundException - Indicates either the master product or the variation group product cannot be found.
*   404 - VariationGroupNotFoundException - Indicates the product does not belong to the master product.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product that contains the variation group.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation group product.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_group`.

#### Responses

*   **400** `ProductIsNotVariationGroupException` - Indicates product specified is not a variation group. or `ProductNotMasterException` - Indicates the master product id does not represent a master product. or `VariationValueNotValidException` - Indicates the values passed are not valid for the variation attributes.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation group product cannot be found. or `VariationGroupNotFoundException` - Indicates the product does not belong to the master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_group`.
    

### GET Get Variations

`GET /products/{master_product_id}/variations`

Operation ID: `Get Variations`. Tags: products. Security: oauth2\_application.

Reads variation for a product master.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates that the given product is not a variation master.
*   404 - ProductNotFoundException - Indicates the master product is not found.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product.  
    Minimum length: 1.
*   `site_id` (query, string) The site context.
*   `start` (query, integer (int32)) The start index of the variations to return (defaults to 0).
*   `count` (query, integer (int32)) The maximum number of variations to return (defaults to 25).
*   `select` (query, string) A selector that specifies the fields to return in the variations document.
*   `expand` (query, array of string) The valid expands are {price,availability}

#### Responses

*   **400** `ProductNotMasterException` - Indicates that the given product is not a variation master.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variants`.
    

### GET Get Variation

`GET /products/{master_product_id}/variations/{id}`

Operation ID: `Get Variation`. Tags: products. Security: oauth2\_application.

Read a variation for a product master.

This endpoint may return the following faults:

*   400 - ProductIsNotVariationException - Indicates the product specified is not a variation.
*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   404 - ProductNotFoundException - Indicates either the master product or the variation product cannot be found.
*   404 - VariationNotFoundException - Indicates the product does not belong to the master product.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product that contains the variation.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation product.  
    Minimum length: 1.
*   `site_id` (query, string)
*   `expand` (query, array of string) The valid expands are {variation,attributes,availability,prices}

#### Responses

*   **400** `ProductIsNotVariationException` - Indicates the product specified is not a variation. or `ProductNotMasterException` - Indicates the master product id does not represent a master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation product cannot be found. or `VariationNotFoundException` - Indicates the product does not belong to the master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variant`.
    

### PUT Assign Variation

`PUT /products/{master_product_id}/variations/{id}`

Operation ID: `Assign Variation`. Tags: products. Security: oauth2\_application.

Assign a variation for a product master. If the variation product does not initially exist, one is created using the body passed in.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   400 - VariationValueNotValidException - Indicates the values passed are not valid for the variation attributes.
*   404 - ProductNotFoundException - Indicates either the master product or the variation product cannot be found.
*   404 - VariationAttributeValueNotFoundException - Indicates the value passed into a variation attribute is not one found in the valid values.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product that contains the variation.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation product.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variant`.

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product id does not represent a master product. or `VariationValueNotValidException` - Indicates the values passed are not valid for the variation attributes.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation product cannot be found. or `VariationAttributeValueNotFoundException` - Indicates the value passed into a variation attribute is not one found in the valid values.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variant`.
    

### DELETE Unassign Variation Product

`DELETE /products/{master_product_id}/variations/{id}`

Operation ID: `Unassign Variation Product`. Tags: products. Security: oauth2\_application.

Unassign a variation product from a product master. The variation product is not deleted: it remains as a normal product after unsassign.

This endpoint may return the following faults:

*   400 - ProductIsNotVariationException - Indicates product specified is not a variation.
*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   404 - ProductNotFoundException - Indicates either the master product or the variation product cannot be found.
*   404 - VariationNotFoundException - Indicates the product does not belong to the master product.

#### Parameters

*   `master_product_id` (path, string, required)  
    Minimum length: 1.
*   `id` (path, string, required)  
    Minimum length: 1.

#### Responses

*   **204**
*   **400** `ProductIsNotVariationException` - Indicates product specified is not a variation. or `ProductNotMasterException` - Indicates the master product id does not represent a master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation product cannot be found. or `VariationNotFoundException` - Indicates the product does not belong to the master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Variation

`PATCH /products/{master_product_id}/variations/{id}`

Operation ID: `Update Variation`. Tags: products. Security: oauth2\_application.

Update a variation for a product master.

This endpoint may return the following faults:

*   400 - ProductIsNotVariationException - Indicates product specified is not a variation.
*   400 - ProductNotMasterException - Indicates the master product id does not represent a master product.
*   400 - VariationValueNotValidException - Indicates the values passed are not valid for the variation attributes.
*   404 - ProductNotFoundException - Indicates either the master product or the variation product cannot be found.
*   404 - VariationNotFoundException - Indicates the product does not belong to the master product.

#### Parameters

*   `master_product_id` (path, string, required) The id of the master product that contains the variation.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation product.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variant`.

#### Responses

*   **400** `ProductIsNotVariationException` - Indicates product specified is not a variation. or `ProductNotMasterException` - Indicates the master product id does not represent a master product. or `VariationValueNotValidException` - Indicates the values passed are not valid for the variation attributes.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates either the master product or the variation product cannot be found. or `VariationNotFoundException` - Indicates the product does not belong to the master product.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variant`.
    

### GET Get Local and Shared Product Options

`GET /products/{product_id}/product_options`

Operation ID: `Get Local and Shared Product Options`. Tags: products. Security: oauth2\_application.

Read local and shared product options of a product.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.
*   `currency` (query, string) The currency mnemonic for retrieving the product option values according to the sorting mode.ex:'USD'

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_options`.
    

### GET Get Local or Shared Product Option

`GET /products/{product_id}/product_options/{id}`

Operation ID: `Get Local or Shared Product Option`. Tags: products. Security: oauth2\_application.

Read a local or shared product option of a product.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local or shared product option is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the local or shared product option.  
    Minimum length: 1.
*   `currency` (query, string) The currency mnemonic for retrieving the product option values according to the sorting mode.ex:'USD'

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local or shared product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option`.
    

### PUT Create Local Product Option, Bind Shared Product Option

`PUT /products/{product_id}/product_options/{id}`

Operation ID: `Create Local Product Option, Bind Shared Product Option`. Tags: products. Security: oauth2\_application.

Creates a local product option using the information provided or binds a shared product option to the product.

This endpoint may return the following faults:

*   400 - ProductOptionCreateException - Indicates the local product option cannot be created for a product of type variation group.
*   404 - ProductNotFoundException - Indicates the product is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the local or shared product option.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option`.

#### Responses

*   **400** `ProductOptionCreateException` - Indicates the local product option cannot be created for a product of type variation group.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option`.
    

### DELETE Delete Local Product Option, Unbind Shared Product Option

`DELETE /products/{product_id}/product_options/{id}`

Operation ID: `Delete Local Product Option, Unbind Shared Product Option`. Tags: products. Security: oauth2\_application.

Deletes a local product option or unbinds a shared product option from the product.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local or shared product option is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the local or shared product option.

#### Responses

*   **204**
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local or shared product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Product Option

`PATCH /products/{product_id}/product_options/{id}`

Operation ID: `Update Product Option`. Tags: products. Security: oauth2\_application.

Updates a local product option with the information provided.

This endpoint may return the following faults:

*   400 - ProductOptionUpdateException - Indicates the shared product option cannot be updated.
*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local product option is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the local product option.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option`.

#### Responses

*   **400** `ProductOptionUpdateException` - Indicates the shared product option cannot be updated.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option`.
    

### GET Get Local Product Option Values

`GET /products/{product_id}/product_options/{option_id}/values`

Operation ID: `Get Local Product Option Values`. Tags: products. Security: oauth2\_application.

Read local product option values of a local product option in a product.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local product option is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the local product option.  
    Minimum length: 1.
*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_values`.
    

### GET Get Local Product Option Value

`GET /products/{product_id}/product_options/{option_id}/values/{id}`

Operation ID: `Get Local Product Option Value`. Tags: products. Security: oauth2\_application.

Read a local product option value of a local product option in a product.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local product option is not found.
*   404 - ProductOptionValueNotFoundException - Indicates the local product option value is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the local product option.  
    Minimum length: 1.
*   `id` (path, string, required) the id of local product option value.  
    Minimum length: 1.

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local product option is not found. or `ProductOptionValueNotFoundException` - Indicates the local product option value is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_value`.
    

### PUT Create Local Product Option Value

`PUT /products/{product_id}/product_options/{option_id}/values/{id}`

Operation ID: `Create Local Product Option Value`. Tags: products. Security: oauth2\_application.

Creates a local product option value using the information provided.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local product option is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the local product option.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the local product option value.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option_value`.

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_value`.
    

### DELETE Delete Local Product Option Value

`DELETE /products/{product_id}/product_options/{option_id}/values/{id}`

Operation ID: `Delete Local Product Option Value`. Tags: products. Security: oauth2\_application.

Deletes a local product option value by ID.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local product option is not found.
*   404 - ProductOptionValueNotFoundException - Indicates the local product option value is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the local product option.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the local product option value.

#### Responses

*   **204**
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local product option is not found. or `ProductOptionValueNotFoundException` - Indicates the local product option value is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Local Product Option Value

`PATCH /products/{product_id}/product_options/{option_id}/values/{id}`

Operation ID: `Update Local Product Option Value`. Tags: products. Security: oauth2\_application.

Updates a local product option value with the information provided.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - ProductOptionNotFoundException - Indicates the local product option is not found.
*   404 - ProductOptionValueNotFoundException - Indicates the local product option value is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the local product option.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the local product option value.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option_value`.

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found. or `ProductOptionNotFoundException` - Indicates the local product option is not found. or `ProductOptionValueNotFoundException` - Indicates the local product option value is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_value`.
    

### GET Get Variation Attributes

`GET /products/{product_id}/variation_attributes`

Operation ID: `Get Variation Attributes`. Tags: products. Security: oauth2\_application.

Reads variation attributes of a product of type variant or variation master or variation group.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - Indicates the product is not found.

#### Parameters

*   `product_id` (path, string, required) The product ID of a variant or a variation master or a variation group.  
    Minimum length: 1.
*   `start` (query, integer (int32))
*   `count` (query, integer (int32))
*   `select` (query, string)

#### Responses

*   **404** `ProductNotFoundException` - Indicates the product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attributes`.
    

### GET Get Product Variation Attribute Values

`GET /products/{product_id}/variation_attributes/{attribute_id}/values`

Operation ID: `Get Product Variation Attribute Values`. Tags: products. Security: oauth2\_application.

Reads variation attribute values of a variation attribute bound to a product.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product is not found.
*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - VariationAttributeNotFoundException - If the attribute id specified is not a valid product attribute.

#### Parameters

*   `product_id` (path, string, required) id of the product  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The variation attribute ID that contains the values.  
    Minimum length: 1.
*   `site_id` (query, string)
*   `start` (query, integer (int32)) the first record to get in the page
*   `count` (query, integer (int32)) the number of records to get
*   `select` (query, string) a string that specifies which fields to return (default is all).
*   `expand` (query, array of string) set of expands to retrieve additional information: {availability, image}

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `VariationAttributeNotFoundException` - If the attribute id specified is not a valid product attribute.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_values`.
    

### GET Get Product Variation Attribute Value

`GET /products/{product_id}/variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Get Product Variation Attribute Value`. Tags: products. Security: oauth2\_application.

Action to get product variation attribute value information.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product is not found.
*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - VariationAttributeValueNotFoundException - If the value id specified is not a valid value id.

#### Parameters

*   `product_id` (path, string, required) The master product ID.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The variation attribute custom ID  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation attribute value  
    Minimum length: 1.
*   `site_id` (query, string) The site context.
*   `expand` (query, array of string) set of expands to retrieve additional information: {availability, image}

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `VariationAttributeValueNotFoundException` - If the value id specified is not a valid value id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.
    

### PUT Put Product Variation Attribute Value

`PUT /products/{product_id}/variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Put Product Variation Attribute Value`. Tags: products. Security: oauth2\_application.

Action to create a product variation attribute value.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product is not found.
*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - VariationAttributeNotFoundException - If the attribute id specified is not a valid product attribute.
*   404 - VariationAttributeValueNotFoundException - If the value id specified is not a valid value id.

#### Parameters

*   `product_id` (path, string, required) The master product ID.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The variation attribute ID  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation attribute value  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `VariationAttributeNotFoundException` - If the attribute id specified is not a valid product attribute. or `VariationAttributeValueNotFoundException` - If the value id specified is not a valid value id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.
    

### DELETE Delete Product Variation Attribute Value

`DELETE /products/{product_id}/variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Delete Product Variation Attribute Value`. Tags: products. Security: oauth2\_application.

Deletes the variation attribute value of a variation attribute bound to a master product

This endpoint may return the following faults:

*   404 - ProductNotFoundException - If the product id specified cannot be found.
*   404 - VariationAttributeNotFoundException - If the attribute id specified is not a valid product attribute.
*   404 - VariationAttributeValueNotFoundException - If the value id specified is not a valid value id.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The id of the variation attribute that contains the value.  
    Minimum length: 1.
*   `id` (path, string, required) The id of one value to remove

#### Responses

*   **204**
*   **404** `ProductNotFoundException` - If the product id specified cannot be found. or `VariationAttributeNotFoundException` - If the attribute id specified is not a valid product attribute. or `VariationAttributeValueNotFoundException` - If the value id specified is not a valid value id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Product Variation Attribute Value

`PATCH /products/{product_id}/variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Update Product Variation Attribute Value`. Tags: products. Security: oauth2\_application.

Updates the variation attribute value of a variation attribute of a master product.

This endpoint may return the following faults:

*   404 - ProductNotFoundException - If the product id specified cannot be found.
*   404 - VariationAttributeNotFoundException - If the attribute id specified is not a valid product attribute.
*   404 - VariationAttributeValueNotFoundException - If the value id specified is not a valid value id.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The id of the requested variation attribute.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation value.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.

#### Responses

*   **404** `ProductNotFoundException` - If the product id specified cannot be found. or `VariationAttributeNotFoundException` - If the attribute id specified is not a valid product attribute. or `VariationAttributeValueNotFoundException` - If the value id specified is not a valid value id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.
    

### GET Get Variation Attribute

`GET /products/{product_id}/variation_attributes/{id}`

Operation ID: `Get Variation Attribute`. Tags: products. Security: oauth2\_application.

Action to get variation attribute information only for master product.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product is not found.
*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - VariationAttributeNotFoundException - Indicates that the variation attribute is not found.

#### Parameters

*   `product_id` (path, string, required) The product ID of a variant or a variation master or a variation group.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested variation attribute.  
    Minimum length: 1.

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `VariationAttributeNotFoundException` - Indicates that the variation attribute is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute`.
    

### PUT Create Variation Attribute

`PUT /products/{product_id}/variation_attributes/{id}`

Operation ID: `Create Variation Attribute`. Tags: products. Security: oauth2\_application.

Creates a local variation attribute using the information provided. This endpoint can't create shared variation attributes. To create a shared variation attribute, use the catalogs resource.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product is not found.
*   400 - ProductVariationAttributeDefinitionNotUniqueException - Indicates that the variation attribute definition is not unique.
*   400 - ProductVariationAttributeIDNotUniqueException - Indicates that the variation attribute id is not unique.
*   500 - AttributeDefinitionNotFoundException - If attribute definition supplied is not a product attribute.
*   404 - ProductNotFoundException - Indicates the product is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation attribute to create.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute`.

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product is not found. or `ProductVariationAttributeDefinitionNotUniqueException` - Indicates that the variation attribute definition is not unique. or `ProductVariationAttributeIDNotUniqueException` - Indicates that the variation attribute id is not unique.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **500** `AttributeDefinitionNotFoundException` - If attribute definition supplied is not a product attribute.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute`.
    

### DELETE Delete Variation Attribute

`DELETE /products/{product_id}/variation_attributes/{id}`

Operation ID: `Delete Variation Attribute`. Tags: products. Security: oauth2\_application.

Deletes a variation attribute by ID.

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product is not found.
*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - VariationAttributeNotFoundException - Indicates that the variation attribute is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `id` (path, string, required) One variation attribute id to remove.

#### Responses

*   **204**
*   **400** `ProductNotMasterException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `VariationAttributeNotFoundException` - Indicates that the variation attribute is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Variation Attribute

`PATCH /products/{product_id}/variation_attributes/{id}`

Operation ID: `Update Variation Attribute`. Tags: products. Security: oauth2\_application.

Updates the variation attribute with the specified information.

*   name
    
*   slicing
    

This endpoint may return the following faults:

*   400 - ProductNotMasterException - Indicates the master product is not found.
*   404 - ProductNotFoundException - Indicates the product is not found.
*   404 - VariationAttributeNotFoundException - Indicates that the variation attribute is not found.

#### Parameters

*   `product_id` (path, string, required) The id of the product.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested variation attribute.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute`.

#### Responses

*   **400** `ProductNotMasterException` - Indicates the master product is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `ProductNotFoundException` - Indicates the product is not found. or `VariationAttributeNotFoundException` - Indicates that the variation attribute is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute`.
    

## Schemas

### fault

Document representing a fault message that is returned whenever the HTTP status code is greater than or equal to 400 (which indicates an error).

*   `arguments` (_object_)
    
    A map that provides fault arguments.
    
    Data can be used to provide error messages on the client side.
    
    Additional properties: `object`.
    
*   `cause` (_cause_)
*   `display_message_pattern` (_string_) The localized display message pattern, if the request parameter display\_locale was given
*   `message` (_string_) The message text of the java exception.
*   `stack_trace` (_string_)
*   `type` (_string_) The name of the java exception.

### product

Document representing a product

*   `assigned_categories` (_array of catalog\_category\_id_) The catalog categories that the product is assigned to
*   `ats` (_number (double)_) The ATS(Available To Sell) inventory value of the product. This is a calculated value.
*   `brand` (_string_) The brand of the product.
*   `bundled_products` (_array of product_) The array of bundled products which the product includes.
*   `classification_category` (_catalog\_category\_id_) The classification category (default category) of the product
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `default_variant_id` (_string_) The ID of the product's default variant.
*   `ean` (_string_) The European Article Number of the product.
*   `id` (_string_) The ID (SKU) of the product.  
    Minimum length: 1. Maximum length: 100.
*   `image` (_media\_file_) The image(s) assigned to the product.
*   `image_groups` (_array of image\_group_) The array of product image groups.
*   `in_stock` (_boolean_) The flag that indicates if the product is in stock, or not. This is a calculated value.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `link` (_string_) A link to the product.
*   `localized_tax_class_id` (_object (localized)_)
    
    Additional properties: `string`.
    
*   `long_description` (_object (localized)_) The localized long description of the product.
    
    Additional properties: `markup_text`.
    
*   `manufacturer_name` (_string_) The name of the product's manufacturer.
*   `manufacturer_sku` (_string_) The SKU of the product's manufacturer.
*   `master` (_master_) The master of the product. This is applicable for product types "variation\_group" and "variant" only.
*   `name` (_object (localized)_) The localized name of the product.
    
    Additional properties: `string`.
    
*   `online` (_boolean_) The flag that indicates if the product is online, or not. This is a calculated value.
*   `online_flag` (_object (site-specific)_) The site specific online status of the product.
    
    Additional properties: `boolean`.
    
*   `owning_catalog_id` (_string_) The ID of the catalog that owns the product.
*   `owning_catalog_name` (_object (localized)_) The localized name of the catalog that owns the product.
    
    Additional properties: `string`.
    
*   `page_description` (_object (localized)_) The localized page description of the product.
    
    Additional properties: `string`.
    
*   `page_keywords` (_object (localized)_) The localized page keywords of the product.
    
    Additional properties: `string`.
    
*   `page_title` (_object (localized)_) The localized page title of the product.
    
    Additional properties: `string`.
    
*   `price` (_number (double)_) The price of the product.
*   `price_currency` (_string_) The currency code for product's price.
*   `price_per_unit` (_number (double)_) The price per unit of the product
*   `primary_categories` (_array of catalog\_category\_id_) The catalog categories that are primary for the product
*   `primary_category_id` (_string_) The id of the products primary category.
*   `product_bundles` (_array of product_) The array of product bundles which the product belongs to.
*   `product_options` (_array of product\_option_) The array of product options. This is applicable for products of type "option".
*   `product_sets` (_array of product_) The array of product sets which the product belongs to.
*   `searchable` (_object (site-specific)_) The site specific searchable status of the product.
    
    Additional properties: `boolean`.
    
*   `set_products` (_array of product_) The array of set products which the product includes.
*   `short_description` (_object (localized)_) The localized short description of the product.
    
    Additional properties: `markup_text`.
    
*   `tax_class_id` (_string_) The catalog categories that the product is assigned to
*   `type` (_product\_type_) The type of the product. It can have one or more of the values "item", "master", "variation\_group", "variant", "bundle", and "set".
*   `unit` (_string_) The sales unit of the product.
*   `unit_measure` (_string_) The unitMeasure of the product.
*   `unit_quantity` (_number (double)_) The unitQuantity of the product.
*   `upc` (_string_) The Universal Product Code of the product.
*   `valid_from` (_object (site-specific)_) The time when product is valid from.
    
    Additional properties: `string (date-time)`.
    
*   `valid_to` (_object (site-specific)_) The time when product is valid to.
    
    Additional properties: `string (date-time)`.
    
*   `variants` (_array of variant_) The array of variants of the product. This is applicable for product types "master" and "variation\_group" only.
*   `variation_attributes` (_array of variation\_attribute_) The sorted array of variation attributes assigned to the product. This is applicable for product types "master", "variation\_group" and "variant" only.
*   `variation_groups` (_array of variation\_group_) The array of variation groups in the product. This is applicable for product type "master" only.
*   `variation_values` (_object_)
    
    The variation values selected for the product in variation attribute id and value pairs. This is applicable for product types "variant" and "variation\_group" only.
    
    ```
         Only for type variant and variation group.
    ```
    
    Additional properties: `string`.
    

_Example_

```
{
  "ats": 500,
  "brand": "Brand",
  "ean": "EAN",
  "id": "my-product",
  "in_stock": true,
  "link": "https://example.com/s/-/dw/data/{version}/products/my-product",
  "long_description": {
    "default": "Long Description"
  },
  "manufacturer_name": "Manufacturer",
  "manufacturer_sku": "Manufacturer ID",
  "name": {
    "default": "My Product"
  },
  "online": true,
  "online_flag": {
    "default": true
  },
  "owning_catalog_id": "my-catalog",
  "owning_catalog_name": {
    "default": "My Catalog"
  },
  "page_description": {
    "default": "Page description"
  },
  "page_keywords": {
    "default": "Page Keyword"
  },
  "page_title": {
    "default": "Page title"
  },
  "price": 100,
  "price_currency": "USD",
  "price_per_unit": 100,
  "searchable": {
    "default": true
  },
  "short_description": {
    "default": "Short Description"
  },
  "type": {
    "bundle": true,
    "bundled": true,
    "part_of_product_set": true
  },
  "unit": "bnd",
  "unit_measure": "each",
  "unit_quantity": 1,
  "upc": "UPC"
}
```

### search\_request

Document representing a search request for retrieving items within the Data API. The query is a potentially complex set of expressions. The fields that each query supports are defined within the search resource.

*   `count` (_integer (int32)_) The number of returned documents  
    Minimum: 1. Maximum: 200.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `query` (_query_, required) The query to apply
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.

### variant\_search\_result

Document that represents a search on certificates and keys.

*   `count` (_integer (int32)_) The number of returned documents
*   `data` (_array of object_)
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `hits` (_array of variant_) The hits from the search
*   `next` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the next result page.
*   `previous` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the previous result page.
*   `query` (_query_) The query passed into the search
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The number of returned documents

_Example_

```
{
  "count": 2,
  "expand": [
    "variations"
  ],
  "hits": [
    {
      "link": "https://ocapi-mon.example.com/s/-/dw/data/{version}/products/dress-spring-red",
      "product_id": "dress-spring-red",
      "variation_values": {
        "color": "red"
      }
    },
    {
      "link": "https://ocapi-mon.example.com/s/-/dw/data/{version}/products/dress-spring-blue",
      "product_id": "dress-spring-blue",
      "variation_values": {
        "color": "blue"
      }
    }
  ],
  "query": {
    "text_query": {
      "fields": [
        "id"
      ],
      "search_phrase": "dress"
    }
  },
  "select": "(**)",
  "start": 0,
  "total": 2
}
```

### variation\_groups

Document representing an unfiltered list of variation groups.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of variation\_group_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-5",
      "product_id": "my-product-5",
      "variation_values": {
        "color": "red"
      }
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-6",
      "product_id": "my-product-6",
      "variation_values": {
        "color": "black"
      }
    }
  ],
  "start": 0,
  "total": 2
}
```

### variation\_group

Document representing a variation group.

*   `link` (_string_) The URL addressing the product.
*   `orderable` (_boolean_) A flag indicating whether the variation group is orderable.
*   `price` (_number (double)_) The sales price of the variation group.
*   `price_per_unit` (_number (double)_) The sales price per unit of the variation group.
*   `product_id` (_string_) The id (SKU) of the variation group.  
    Minimum length: 1. Maximum length: 100.
*   `variation_values` (_object_) The actual variation attribute id - value pairs.
    
    Additional properties: `string`.
    

_Example_

```
{
  "link": "https://example.com/s/-/dw/data/{version}/products/my-product-5",
  "product_id": "my-product-5",
  "variation_values": {
    "color": "red"
  }
}
```

### variants

Document representing an unfiltered list of variants.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of variant_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 9,
  "data": [
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-1",
      "product_id": "my-product-1"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-2",
      "product_id": "my-product-2"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-3",
      "product_id": "my-product-3"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-4",
      "product_id": "my-product-4"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-5",
      "product_id": "my-product-5"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-6",
      "product_id": "my-product-6"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-7",
      "product_id": "my-product-7"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-8",
      "product_id": "my-product-8"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product-9",
      "product_id": "my-product-9"
    }
  ],
  "start": 0,
  "total": 9
}
```

### variant

Document representing a product variation.

*   `ats` (_number (double)_) Inventory "Available to Sell" of the product.
*   `default_product_variation` (_boolean_)
*   `image` (_media\_file_) URL to the preview image.
*   `in_stock` (_boolean_) `true` if the product is in stock, or `false` if not.
*   `link` (_string_) The URL addressing the product.
*   `online` (_boolean_) If the product is currently online. `true` if online `false` if not
*   `orderable` (_boolean_) A flag indicating whether the variant is orderable.
*   `price` (_number (double)_) The sales price of the variant.
*   `price_currency` (_string_) Currency code for the price of the product.
*   `price_per_unit` (_number (double)_) The sales price of the variant.
*   `product_id` (_string_, required) The id (SKU) of the variant.  
    Minimum length: 1. Maximum length: 100.
*   `searchable` (_object (site-specific)_)
    
    Additional properties: `boolean`.
    
*   `variation_attributes` (_array of variation\_attribute_) variation attributes
*   `variation_values` (_object_) The actual variation attribute id - value pairs.
    
    Additional properties: `string`.
    

_Example_

```
{
  "link": "https://ocapi-mon.example.com/s/-/dw/data/{version}/products/dress-spring-red",
  "product_id": "dress-spring-red",
  "variation_values": {
    "color": "red"
  }
}
```

### product\_options

Document representing an unfiltered list of product options.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of product\_option_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "custom_name": {
        "default": "Shared Service"
      },
      "default_product_option_value": "S00",
      "description": {
        "default": "Service description"
      },
      "id": "service",
      "image": {
        "abs_url": "https://example.com/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
        "dis_base_url": "https://example.com/dw/image/v2/zzzz_s01/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
        "path": "Desert.jpg"
      },
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service",
      "name": "Shared Service",
      "shared": true,
      "sorting_mode": "byexplicitorder",
      "values": [
        {
          "id": "S00",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service/Values/S00",
          "sku_extension": "S00",
          "value": {
            "default": "None"
          }
        },
        {
          "id": "S01",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service/Values/S01",
          "option_price": {
            "USD": "9.99"
          },
          "sku_extension": "S01",
          "value": {
            "default": "1-year"
          }
        },
        {
          "id": "S02",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service/Values/S02",
          "option_price": {
            "USD": "19.99"
          },
          "sku_extension": "S02",
          "value": {
            "default": "2-year"
          }
        }
      ]
    },
    {
      "custom_name": {
        "default": "Extended Warranty"
      },
      "default_product_option_value": "000",
      "id": "warranty",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty",
      "name": "Extended Warranty",
      "shared": true,
      "sorting_mode": "byoptionprice",
      "values": [
        {
          "id": "001",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/001",
          "option_price": {
            "USD": "9.99"
          },
          "value": {
            "default": "1 Year Warranty"
          }
        },
        {
          "id": "003",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/003",
          "option_price": {
            "USD": "29.99"
          },
          "value": {
            "default": "5 Year Warranty"
          }
        },
        {
          "id": "000",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/000",
          "option_price": {
            "USD": "39.99"
          },
          "value": {
            "default": "None"
          }
        },
        {
          "id": "002",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/002",
          "option_price": {
            "USD": "49.99"
          },
          "value": {
            "default": "3 Year Warranty"
          }
        }
      ]
    }
  ],
  "select": "(**)",
  "start": 0,
  "total": 2
}
```

### product\_option

Document representing a product option

*   `custom_name` (_object (localized)_) The localized custom name of the product option.
    
    Additional properties: `string`.
    
*   `default_product_option_value` (_string_) The default product option value.
*   `description` (_object (localized)_) The localized description of the product option.
    
    Additional properties: `string`.
    
*   `id` (_string_) The object attribute definition id which is also the identifier for the product option.  
    Minimum length: 1.
*   `image` (_media\_file_) The image assigned to the product option.
*   `link` (_string_) The URL link to the product option.
*   `name` (_string_) The name of the object attribute definition.
*   `selected_option_value` (_string_) The selected option value of the product option.
*   `shared` (_boolean_) The flag that indicates if the product option is shared or local.
*   `sorting_mode` (_string_) The sorting mode for the product option values.  
    Allowed values: `byexplicitorder`, `byoptionprice`.
*   `values` (_array of product\_option\_value_) The sorted array of values of the product option.

_Example_

```
{
  "custom_name": {
    "default": "Option 15"
  },
  "description": {
    "default": "Description for Option 15"
  },
  "id": "option15",
  "image": {
    "abs_url": "https://example.com/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
    "dis_base_url": "https://example.com/dw/image/v2/zzzz_s01/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
    "path": "Desert.jpg"
  },
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15",
  "name": "15",
  "shared": true,
  "sorting_mode": "byoptionprice",
  "values": [
    {
      "id": "10",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15/Values/10",
      "option_price": {
        "USD": "9.99"
      },
      "sku_extension": "12",
      "value": {
        "default": "12"
      }
    },
    {
      "id": "121",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15/Values/121",
      "option_price": {
        "USD": "19.99"
      },
      "sku_extension": "12",
      "value": {
        "default": "12"
      }
    }
  ]
}
```

### product\_option\_values

Document representing an unfiltered list of product option values.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of product\_option\_value_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 3,
  "data": [
    {
      "default_product_option_value": true,
      "id": "value1",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S00",
      "sku_extension": "S00",
      "value": {
        "default": "None",
        "en": "None (en)"
      }
    },
    {
      "default_product_option_value": false,
      "id": "value2",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S01",
      "option_prices": [
        {
          "currency_mnemonic": "USD",
          "value": 9.99
        }
      ],
      "sku_extension": "S01",
      "value": {
        "default": "1-year",
        "en": "1-year (en)"
      }
    },
    {
      "default_product_option_value": false,
      "id": "value3",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S02",
      "option_prices": [
        {
          "currency_mnemonic": "USD",
          "value": 19.99
        }
      ],
      "sku_extension": "S02",
      "value": {
        "default": "2-year",
        "en": "2-year (en)"
      }
    }
  ],
  "select": "(**)",
  "start": 0,
  "total": 3
}
```

### product\_option\_value

Document representing a product option Value

*   `default_product_option_value` (_boolean_) Flag indicating if the product option value is the default value for the product option.
*   `id` (_string_) The id of the product option value.  
    Minimum length: 1.
*   `link` (_string_) The URL link to the product option value.
*   `option_prices` (_array of money_) The list of prices in the product option value.
*   `sku_extension` (_string_) The sku extension of the product option value.
*   `value` (_object (localized)_) The localized value of the product option.
    
    Additional properties: `string`.
    

_Example_

```
{
  "default_product_option_value": false,
  "id": "value3",
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S02",
  "option_prices": [
    {
      "currency_mnemonic": "USD",
      "value": 19.99
    }
  ],
  "sku_extension": "S02",
  "value": {
    "default": "2-year",
    "en": "2-year (en)"
  }
}
```

### variation\_attributes

Document representing an unfiltered list of variation attributes.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of variation\_attribute_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 3,
  "data": [
    {
      "id": "fabric",
      "name": {
        "default": "Fabric"
      },
      "values": [
        {
          "name": {
            "default": "Leather"
          },
          "value": "leather"
        },
        {
          "name": {
            "default": "Linen"
          },
          "value": "linen"
        },
        {
          "name": {
            "default": "Plastic"
          },
          "value": "plastic"
        },
        {
          "name": {
            "default": "Metal"
          },
          "value": "metal"
        }
      ]
    },
    {
      "id": "color",
      "name": {
        "default": "Color"
      },
      "values": [
        {
          "name": {
            "default": "Red"
          },
          "value": "red"
        },
        {
          "name": {
            "default": "Blue"
          },
          "value": "blue"
        },
        {
          "name": {
            "default": "Black"
          },
          "value": "black"
        }
      ]
    },
    {
      "id": "size",
      "name": {
        "default": "Size"
      },
      "values": [
        {
          "description": {
            "default": "Small"
          },
          "name": {
            "default": "Small"
          },
          "value": "S"
        },
        {
          "description": {
            "default": "Medium"
          },
          "name": {
            "default": "Medium"
          },
          "value": "M"
        },
        {
          "description": {
            "default": "Large"
          },
          "name": {
            "default": "Large"
          },
          "value": "L"
        }
      ]
    }
  ],
  "start": 0,
  "total": 3
}
```

### variation\_attribute\_values

Document representing an unfiltered list of variation attribute values.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of variation\_attribute\_value_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 3,
  "data": [
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/master_product_1/variation_attributes/color/values/red",
      "value": "red"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/master_product_1/variation_attributes/color/values/blue",
      "value": "blue"
    },
    {
      "link": "https://example.com/s/-/dw/data/{version}/products/master_product_1/variation_attributes/color/values/black",
      "value": "black"
    }
  ],
  "select": "(*,data.(value,link))",
  "start": 0,
  "total": 3
}
```

### variation\_attribute\_value

Document representing a variation attribute value.

*   `description` (_object (localized)_) The localized description of the variation value.
    
    Additional properties: `string`.
    
*   `image` (_media\_file_) The first product image for the configured viewtype and this variation value.
*   `image_swatch` (_media\_file_) The first product image for the configured viewtype and this variation value. (typically the swatch image)
*   `link` (_string_)
*   `name` (_object (localized)_) The localized display name of the variation value.
    
    Additional properties: `string`.
    
*   `orderable` (_boolean_) A flag indicating whether at least one variant with this variation attribute value is available to sell.
*   `position` (_number (double)_) The position of the value among all values of a variation attribute.
*   `value` (_string_, required) The actual variation value.  
    Minimum length: 1.

_Example_

```
{
  "name": {
    "default": "Leather"
  },
  "value": "leather"
}
```

### variation\_attribute

Document representing a variation attribute.

*   `attribute_definition_id` (_string_, required) The id of the requested attribute definition.
*   `attribute_definition_name` (_object (localized)_) The localized display name of the variation attribute definition.
    
    Additional properties: `string`.
    
*   `default_value` (_string_) default variation attribute value
*   `id` (_string_) The id of the variation attribute.  
    Minimum length: 1.
*   `link` (_string_) URL that is used to get this instance
*   `name` (_object (localized)_) The localized display name of the variation attribute.
    
    Additional properties: `string`.
    
*   `shared` (_boolean_) Returns the value of attribute 'shared' if attribute is local or shared
*   `slicing` (_boolean_) Returns the value of attribute 'slicing'.
*   `values` (_array of variation\_attribute\_value_) The sorted array of variation values. This array can be empty.
*   `variation_attribute_type` (_string_) variation attribute type  
    Allowed values: `string`, `int`, `unknown`.

_Example_

```
{
  "id": "fabric",
  "name": {
    "default": "Fabric"
  },
  "values": [
    {
      "name": {
        "default": "Leather"
      },
      "value": "leather"
    },
    {
      "name": {
        "default": "Linen"
      },
      "value": "linen"
    },
    {
      "name": {
        "default": "Plastic"
      },
      "value": "plastic"
    },
    {
      "name": {
        "default": "Metal"
      },
      "value": "metal"
    }
  ]
}
```

### cause

*   `cause` (_cause_)
*   `message` (_string_)
*   `type` (_string_)

### catalog\_category\_id

Document representing a catalog category id.

*   `catalog_id` (_string_) The id of the catalog that owns the category.  
    Minimum length: 1. Maximum length: 256.
*   `category_id` (_string_) The id of the category.  
    Minimum length: 1. Maximum length: 256.

### media\_file

*   `abs_url` (_string_) The absolute URL with request protocol (read only)
*   `alt` (_object (localized)_) The alternative image text
    
    Additional properties: `string`.
    
*   `dis_base_url` (_string_) The DIS base URL only for product images
*   `path` (_string_) The raw media file path (only this needs to be provided in update request)
*   `title` (_object (localized)_) The image title
    
    Additional properties: `string`.
    

_Example_

```
{
  "path": "option.jpg"
}
```

### image\_group

Document representing an image group containing a list of images for a particular view type and an optional variation value.

*   `images` (_array of media\_file_) The images of the image group.
*   `variation_attributes` (_array of variation\_attribute_) Returns a list of variation attributes applying to this image group.
*   `view_type` (_string_) The image view type.

### markup\_text

*   `markup` (_string_) The rendered HTML (read only)
*   `source` (_string_) The raw markup text (only this needs to be provided in update request)

### master

Document representing a variation master.

*   `link` (_string_) The URL addressing the master product.
*   `master_id` (_string_, required) The id (SKU) of the master product.  
    Minimum length: 1. Maximum length: 100.
*   `orderable` (_boolean_) A flag indicating whether at least one of the variants is orderable.
*   `price` (_number (double)_) The minimum sales price of the related variants.
*   `price_max` (_number (double)_) The maximum sales of related variants.
*   `price_per_unit` (_number (double)_) The minimum sales price per unit of the related variants.
*   `price_per_unit_max` (_number (double)_) The maximum sales price per unit of the related variants.
*   `prices` (_object_)
    
    Additional properties: `number (double)`.
    

### product\_type

Document representing a product type.

*   `bundle` (_boolean_) A flag indicating whether the product is a bundle.
*   `bundled` (_boolean_) A flag indicating whether the product is bundled.
*   `item` (_boolean_) A flag indicating whether the product is a standard item.
*   `master` (_boolean_) A flag indicating whether the product is a master.
*   `option` (_boolean_) A flag indicating whether the product is an option.
*   `part_of_product_set` (_boolean_) A flag indicating whether the product is part of product set.
*   `part_of_retail_set` (_boolean_) A flag indicating whether the product is part of retail set.
*   `retail_set` (_boolean_) A flag indicating whether the product is a retail set.
*   `set` (_boolean_) A flag indicating whether the product is a set.
*   `variant` (_boolean_) A flag indicating whether the product is a variant.
*   `variation_group` (_boolean_) A flag indicating whether the product is a variation group.

_Example_

```
{
  "bundled": true,
  "master": true,
  "part_of_product_set": true
}
```

### query

Document representing a query. A query contains a set of objects that define criteria used to select records. A query can contain one of the following:

*   match\_all\_query - returns all records.
    
*   term\_query - matches records where a field (or fields) exactly match some simple value (including null).
    
*   text\_query - matches records where a field (or fields) contain a search phrase.
    
*   boolean\_query - formulates a complex boolean expression using query objects as criteria.
    
*   filtered\_query - allows for filtering of records based on both a query and a filter.
    

Type: `any`.

### sort

Document representing a sort request.

*   `field` (_string_, required) The name of the field to sort on.
*   `sort_order` (_string_) The sort order to be applied when sorting. When omitted, the default sort order (ASC) is used.  
    Allowed values: `asc`, `desc`.

_Example_

```
{
  "field": "id",
  "sort_order": "asc"
}
```

### result\_page

Data that can be used to get the next and previous page of a Data API results object.

*   `count` (_integer (int32)_) The number of returned documents.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.

### money

*   `currency_mnemonic` (_string_) The mnemonic for the money.
*   `value` (_number (double)_) The value for the money.

_Example_

```
{
  "currency_mnemonic": "USD",
  "value": 100
}
```

### bool\_filter

Document representing a boolean filter.

A boolean filter allows you to combine other filters into (possibly recursive) logical expression trees. A boolean filter is configured with a boolean operator (AND, OR, NOT) and a list of filters the operator relates to. If multiple filters are given to a boolean NOT operator, this is interpreted as a NOT upon a boolean OR of the given filters.

**Example:** (id="myId" AND coupon\_id="couponOne")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "and",
filters: \[
{ term\_filter: { field: "id", operator: "is", values: \["myId"\] } },
{ term\_filter: { field: "coupon\_id", operator: "is", values: \["couponOne"\] } }
\]
}
}
}
}

**Example:** (id="holidaySale" OR redemption\_count BETWEEN(1, 20)

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "or",
filters: \[
{ term\_filter: { field: "id", operator: "is", values: \["holidaySale"\] } },
{ range\_filter: { field: "redemption\_count", from: 1, to: 20 } }
\]
}
}
}
}

**Example:** NOT(enabled=false OR coupon\_id="special")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "not",
filters: \[
{ term\_filter: { field: "enabled", operator: "is", values: \[false\] } },
{ term\_filter: { field: "coupon\_id", operator: "is", values: \["special"\] } }
\]
}
}
}
}

*   `filters` (_array of filter_) A list of filters, which are logically combined by an operator.
*   `operator` (_string_, required) The logical operator the filters are combined with.  
    Allowed values: `and`, `or`, `not`.

### bool\_query

A boolean query allows construction of full logical expression trees consisting of other queries (usually term and text queries). A boolean query basically has 3 sets of clauses that 'must', 'should' and / or 'must not' match. If 'must', 'must\_not', or 'should' appear in the same boolean query, they are combined logically using the AND operator. The difference between must and should operators is that the must operator requires all subqueries to match whereas the should operator only requires one match

**Example:** (id = 'foo' AND description LIKE 'bar')

query: {
bool\_query: {
must: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** (id = 'foo' OR description LIKE 'bar')

query: {
bool\_query: {
should: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** (NOT (id = 'foo' AND description LIKE 'bar'))

query: {
bool\_query: {
must\_not: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** ((coupon\_id LIKE "limit" AND description LIKE "limit per customer") AND NOT (enabled=false))

query: {
bool\_query: {
must: \[
{ text\_query: { fields: \[ "coupon\_id" \], search\_phrase: "limit" } },
{ text\_query: { fields: \[ "description" \], search\_phrase: "limit per customer" } }
\],
must\_not: \[
{ term\_query: { fields: \[ "enabled" \], operator: "is", values: \[false\] } }
\]
}
}

*   `must` (_array of query_) List of queries that must match.
*   `must_not` (_array of query_) List of queries that must not match.
*   `should` (_array of query_) List of queries that should match (i.e., at least one query must match).

### filter

Document representing a filter.

A filter contains a set of objects that define criteria used to select records. A filter can contain one of the following:

*   term\_filter - matches records where a field (or fields) exactly match some simple value (including null).
    
*   range\_filter - matches records where a field value lies in a specified range.
    
*   query\_filter - provides filtering based on a query.
    
*   bool\_filter - provides filtering of records using a set of filters combined with a specified operator.
    

Type: `any`.

### filtered\_query

A filtered query allows to filter the result of a (possibly complex) query using a (possibly complex) filter.

**Example:**

query : {
filtered\_query: {
query: {
text\_query: { fields: \["coupon\_id"\], search\_phrase: "disabled" }
},
filter: {
term\_filter: {
field: "enabled", operator: "is", values: \[ false \]
}
}
}
}

*   `filter` (_filter_, required) The (possibly complex) filter object.
*   `query` (_query_, required) The query object.

### match\_all\_query

A match all query simply matches all documents (namespace and document type). This query comes in handy if you just want to filter a search result or really do not have any constraints.

**Example:**

query: {
match\_all\_query: {}
}

Type: `any`.

### nested\_query

A nested query queries nested documents that are part of a larger document. The classical example is a product master with variants (in one big document) where you want to constrain a search to masters that have variants that match multiple constraints (like color = blue AND size = M). This query is not compatible with some search types. **Example:** finds all the documents that has firstname = "John" and lastname = "Doe"

{
"query": {
"bool\_query": {
"must": \[
{
"nested\_query": {
"path": "order.shipping\_addresses",
"query": {
"bool\_query": {
"must": \[
{
"bool\_query": {
"must": \[
{
"term\_query": {
"fields": \[ "order.shipping\_addresses.first\_name" \],
"operator": "is",
"values": \[ "John" \]
}
}
\]
}
},
{
"bool\_query": {
"must": \[
{
"term\_query": {
"fields": \[ "order.shipping\_addresses.last\_name" \],
"operator": "is",
"values": \[ "Doe" \]
}
}
\]
}
}
\]
}
},
"score\_mode": "avg"
}
}
\]
}
}
}

*   `path` (_string_, required)
*   `query` (_query_, required)
*   `score_mode` (_string_)  
    Allowed values: `avg`, `total`, `max`, `none`.

### query\_filter

Document representing a query filter. A query filter wraps any query and allows it to be used as a filter.

**Example:** (coupon\_id contains "disabled" AND (enabled=false OR active=false))

query : {
filtered\_query: {
query: { text\_query: { fields: \["coupon\_id"\], search\_phrase: "disabled" } },
filter: {
query\_filter: {
query: {
term\_query: { fields: \["enabled","active"\], operator: "is", values: \[ false \] }
}
}
}
}
}

*   `query` (_query_, required) The query to use as a filter.

### range2\_filter

Document representing a range comparison with a range filter, named Range2Filter.

A Range2Filter allows you to restrict a search result to hits where a range defined by specified attributes has a certain relationship to a specified range.

[...]
